diff --git a/.appveyor.yml b/.appveyor.yml
index db6ba5e866..eb76a4e0d5 100644
--- a/.appveyor.yml
+++ b/.appveyor.yml
@@ -9,9 +9,9 @@ branches:
 
 environment:
   matrix:
+  - llvm: 5.0.0
+  - llvm: 4.0.1
   - llvm: 3.9.1
-  - llvm: 3.8.1
-  - llvm: 3.7.1
 
 configuration:
   - release
diff --git a/.travis.yml b/.travis.yml
index 6ea250a8d9..eb6ab5274d 100644
--- a/.travis.yml
+++ b/.travis.yml
@@ -113,6 +113,66 @@ matrix:
         - ICC1=gcc-6
         - ICXX1=g++-6
 
+    - os: linux
+      addons:
+        apt:
+          sources:
+            - ubuntu-toolchain-r-test
+          packages:
+            - g++-6
+      env:
+        - FAVORITE_CONFIG=no
+        - LLVM_VERSION="4.0.1"
+        - LLVM_CONFIG="llvm-config-4.0"
+        - config=debug
+        - CC1=gcc-6
+        - CXX1=g++-6
+
+    - os: linux
+      addons:
+        apt:
+          sources:
+            - ubuntu-toolchain-r-test
+          packages:
+            - g++-6
+      env:
+        - FAVORITE_CONFIG=no
+        - LLVM_VERSION="4.0.1"
+        - LLVM_CONFIG="llvm-config-4.0"
+        - config=release
+        - CC1=gcc-6
+        - CXX1=g++-6
+
+    - os: linux
+      addons:
+        apt:
+          sources:
+            - ubuntu-toolchain-r-test
+          packages:
+            - g++-6
+      env:
+        - FAVORITE_CONFIG=no
+        - LLVM_VERSION="5.0.0"
+        - LLVM_CONFIG="llvm-config-5.0"
+        - config=debug
+        - CC1=gcc-6
+        - CXX1=g++-6
+
+    - os: linux
+      addons:
+        apt:
+          sources:
+            - ubuntu-toolchain-r-test
+          packages:
+            - g++-6
+      env:
+        - FAVORITE_CONFIG=no
+        - LLVM_VERSION="5.0.0"
+        - LLVM_CONFIG="llvm-config-5.0"
+        - config=release
+        - CC1=gcc-6
+        - CXX1=g++-6
+
     - os: osx
       env:
         - FAVORITE_CONFIG=no
@@ -170,6 +230,44 @@ matrix:
         - CC1=clang-3.9
         - CXX1=clang++-3.9
 
+    - os: osx
+      env:
+        - FAVORITE_CONFIG=no
+        - LLVM_VERSION="4.0.1"
+        - LLVM_CONFIG="llvm-config-4.0"
+        - config=debug
+        - CC1=clang-4.0
+        - CXX1=clang++-4.0
+
+    - os: osx
+      env:
+        - FAVORITE_CONFIG=no
+        - LLVM_VERSION="4.0.1"
+        - LLVM_CONFIG="llvm-config-4.0"
+        - config=release
+        - lto=no
+        - CC1=clang-4.0
+        - CXX1=clang++-4.0
+
+    - os: osx
+      env:
+        - FAVORITE_CONFIG=no
+        - LLVM_VERSION="5.0.0"
+        - LLVM_CONFIG="llvm-config-5.0"
+        - config=debug
+        - CC1=clang-5.0
+        - CXX1=clang++-5.0
+
+    - os: osx
+      env:
+        - FAVORITE_CONFIG=no
+        - LLVM_VERSION="5.0.0"
+        - LLVM_CONFIG="llvm-config-5.0"
+        - config=release
+        - lto=no
+        - CC1=clang-5.0
+        - CXX1=clang++-5.0
+
 rvm:
   - 2.2.3
 
diff --git a/.travis_install.bash b/.travis_install.bash
index 233d1e79d3..72c809fe2c 100644
--- a/.travis_install.bash
+++ b/.travis_install.bash
@@ -56,6 +56,16 @@ case "${TRAVIS_OS_NAME}:${LLVM_CONFIG}" in
     set_linux_compiler
   ;;
 
+  "linux:llvm-config-4.0")
+    download_llvm
+    download_pcre
+  ;;
+
+  "linux:llvm-config-5.0")
+    download_llvm
+    download_pcre
+  ;;
+
   "osx:llvm-config-3.7")
     brew update
     brew install pcre2
@@ -90,6 +100,42 @@ case "${TRAVIS_OS_NAME}:${LLVM_CONFIG}" in
     #export PATH=llvmsym/:$PATH
   ;;
 
+  "osx:llvm-config-4.0")
+    brew update
+    brew install shellcheck
+    shellcheck ./.*.bash ./*.bash
+
+    brew install pcre2
+    brew install libressl
+
+    brew install llvm
+    brew link --overwrite --force llvm
+    mkdir llvmsym
+    ln -s "$(which llvm-config)" llvmsym/llvm-config-4.0
+    ln -s "$(which clang++)" llvmsym/clang++-4.0
+
+    # do this elsewhere:
+    export PATH=llvmsym/:$PATH
+  ;;
+
+  "osx:llvm-config-5.0")
+    brew update
+    brew install shellcheck
+    shellcheck ./.*.bash ./*.bash
+
+    brew install pcre2
+    brew install libressl
+
+    brew install llvm
+    brew link --overwrite --force llvm
+    mkdir llvmsym
+    ln -s "$(which llvm-config)" llvmsym/llvm-config-5.0
+    ln -s "$(which clang++)" llvmsym/clang++-5.0
+
+    # do this elsewhere:
+    export PATH=llvmsym/:$PATH
+  ;;
+
   *)
     echo "ERROR: An unrecognized OS and LLVM tuple was found! Consider OS: ${TRAVIS_OS_NAME} and LLVM: ${LLVM_CONFIG}"
     exit 1
diff --git a/.travis_script.bash b/.travis_script.bash
index 464a4969a9..ad226d7f9d 100644
--- a/.travis_script.bash
+++ b/.travis_script.bash
@@ -83,6 +83,14 @@ case "${TRAVIS_OS_NAME}:${LLVM_CONFIG}" in
     fi
   ;;
 
+  "linux:llvm-config-4.0")
+    ponyc-test
+  ;;
+
+  "linux:llvm-config-5.0")
+    ponyc-test
+  ;;
+
   "osx:llvm-config-3.7")
     ponyc-test
   ;;
@@ -96,6 +104,16 @@ case "${TRAVIS_OS_NAME}:${LLVM_CONFIG}" in
     ponyc-test
   ;;
 
+  "osx:llvm-config-4.0")
+    export PATH=llvmsym/:$PATH
+    ponyc-test
+  ;;
+
+  "osx:llvm-config-5.0")
+    export PATH=llvmsym/:$PATH
+    ponyc-test
+  ;;
+
   *)
     echo "ERROR: An unrecognized OS and LLVM tuple was found! Consider OS: ${TRAVIS_OS_NAME} and LLVM: ${LLVM_CONFIG}"
     exit 1
diff --git a/Makefile b/Makefile
index b44106721c..46a4ddb29a 100644
--- a/Makefile
+++ b/Makefile
@@ -193,14 +193,30 @@ ifeq ($(OSTYPE),osx)
 endif
 
 ifndef LLVM_CONFIG
-	ifneq (,$(shell which /usr/local/opt/llvm@3.9/bin/llvm-config 2> /dev/null))
-    LLVM_CONFIG = /usr/local/opt/llvm@3.9/bin/llvm-config
-    LLVM_LINK = /usr/local/opt/llvm@3.9/bin/llvm-link
-    LLVM_OPT = /usr/local/opt/llvm@3.9/bin/opt
+	ifneq (,$(shell which /usr/local/opt/llvm/bin/llvm-config 2> /dev/null))
+    LLVM_CONFIG = /usr/local/opt/llvm/bin/llvm-config
+    LLVM_LINK = /usr/local/opt/llvm/bin/llvm-link
+    LLVM_OPT = /usr/local/opt/llvm/bin/opt
+  else ifneq (,$(shell which llvm-config-5.0 2> /dev/null))
+    LLVM_CONFIG = llvm-config-5.0
+    LLVM_LINK = llvm-link-5.0
+    LLVM_OPT = opt-5.0
+  else ifneq (,$(shell which llvm-config-4.0 2> /dev/null))
+    LLVM_CONFIG = llvm-config-4.0
+    LLVM_LINK = llvm-link-4.0
+    LLVM_OPT = opt-4.0
+	else ifneq (,$(shell which /usr/local/opt/llvm@4.0/bin/llvm-config 2> /dev/null))
+    LLVM_CONFIG = /usr/local/opt/llvm@4.0/bin/llvm-config
+    LLVM_LINK = /usr/local/opt/llvm@4.0/bin/llvm-link
+    LLVM_OPT = /usr/local/opt/llvm@4.0/bin/opt
   else ifneq (,$(shell which llvm-config-3.9 2> /dev/null))
     LLVM_CONFIG = llvm-config-3.9
     LLVM_LINK = llvm-link-3.9
-    LLVM_OPT = opt-3.9
+		LLVM_OPT = opt-3.9
+  else ifneq (,$(shell which /usr/local/opt/llvm@3.9/bin/llvm-config 2> /dev/null))
+    LLVM_CONFIG = /usr/local/opt/llvm@3.9/bin/llvm-config
+    LLVM_LINK = /usr/local/opt/llvm@3.9/bin/llvm-link
+    LLVM_OPT = /usr/local/opt/llvm@3.9/bin/opt
   else ifneq (,$(shell which llvm-config-3.8 2> /dev/null))
     LLVM_CONFIG = llvm-config-3.8
     LLVM_LINK = llvm-link-3.8
@@ -248,7 +264,6 @@ llvm_version := $(shell $(LLVM_CONFIG) --version)
 
 ifeq ($(OSTYPE),osx)
 	llvm_bindir := $(shell $(LLVM_CONFIG) --bindir)
-
   ifneq (,$(shell which $(llvm_bindir)/llvm-ar 2> /dev/null))
     AR = $(llvm_bindir)/llvm-ar
     AR_FLAGS := rcs
@@ -267,9 +282,11 @@ endif
 ifeq ($(llvm_version),3.7.1)
 else ifeq ($(llvm_version),3.8.1)
 else ifeq ($(llvm_version),3.9.1)
+else ifeq ($(llvm_version),4.0.1)
+else ifeq ($(llvm_version),5.0.0)
 else
   $(warning WARNING: Unsupported LLVM version: $(llvm_version))
-  $(warning Please use LLVM 3.7.1, 3.8.1, or 3.9.1)
+  $(warning Please use LLVM 3.7.1, 3.8.1, 3.9.1, 4.0.1 or 5.0.0)
 endif
 
 compiler_version := "$(shell $(CC) --version | sed -n 1p)"
diff --git a/README.md b/README.md
index f871341b8c..525f136f62 100644
--- a/README.md
+++ b/README.md
@@ -247,6 +247,8 @@ Pony requires one of the following versions of LLVM:
 - 3.7.1
 - 3.8.1
 - 3.9.1
+- 4.0.1
+- 5.0.0
 
 Compiling Pony is only possible on x86 and ARM (either 32 or 64 bits).
 
@@ -393,7 +395,7 @@ Build ponyc, compile and run helloworld:
 
 ```bash
 cd ~/ponyc/
-make 
+make
 ./build/release/ponyc examples/helloworld
 ./helloworld
 ```
@@ -494,7 +496,7 @@ make default_pic=true
 
 You need to have the development versions of the following installed:
 
-* LLVM 3.7.1, 3.8.1, or 3.9.1
+* LLVM 3.7.1, 3.8.1, 3.9.1, 4.0.1, or 5.0.0
 * zlib
 * ncurses
 * pcre2
@@ -562,7 +564,7 @@ Please note that on 32-bit X86, using LLVM 3.7.1 or 3.8.1 on FreeBSD currently p
 ## Building on Mac OS X
 [![Linux and OS X](https://travis-ci.org/ponylang/ponyc.svg?branch=master)](https://travis-ci.org/ponylang/ponyc)
 
-You'll need llvm 3.7.1, 3.8.1 or 3.9.1 and the pcre2 library to build Pony. You can use either homebrew or MacPorts to install your dependencies. Please note that llvm 3.9.1 is not available via homebrew. As such, the instructions below install 3.8.1
+You'll need llvm 3.7.1, 3.8.1, 3.9.1, 4.0.1, or 5.0.0 and the pcre2 library to build Pony. You can use either homebrew or MacPorts to install your dependencies. Please note that llvm 3.9.1 is not available via homebrew. As such, the instructions below install 3.8.1
 
 Installation via [homebrew](http://brew.sh):
 ```
@@ -618,8 +620,8 @@ This will automatically perform the following steps:
 
 You can provide the following options to `make.bat` when running the `build` or `test` commands:
 
-- `--config debug|release`: whether or not to build a debug or release build (debug is the default).
-- `--llvm <version>`: the LLVM version to build against (3.9.1 is the default).
+- `--config debug|release`: whether or not to build a debug or release build (`release` is the default).
+- `--llvm <version>`: the LLVM version to build against (`5.0.0` is the default).
 
 Note that you need to provide these options each time you run make.bat; the system will not remember your last choice.
 
diff --git a/src/libponyc/codegen/codegen.h b/src/libponyc/codegen/codegen.h
index adff76e5ab..7b18330198 100644
--- a/src/libponyc/codegen/codegen.h
+++ b/src/libponyc/codegen/codegen.h
@@ -41,12 +41,14 @@ LLVMValueRef LLVMConstInf(LLVMTypeRef type, bool negative);
 LLVMModuleRef LLVMParseIRFileInContext(LLVMContextRef ctx, const char* file);
 bool LLVMHasMetadataStr(LLVMValueRef val, const char* str);
 void LLVMSetMetadataStr(LLVMValueRef val, const char* str, LLVMValueRef node);
+void LLVMMDNodeReplaceOperand(LLVMValueRef parent, unsigned i,
+  LLVMValueRef node);
 
 // Intrinsics.
 LLVMValueRef LLVMMemcpy(LLVMModuleRef module, bool ilp32);
 LLVMValueRef LLVMMemmove(LLVMModuleRef module, bool ilp32);
-LLVMValueRef LLVMLifetimeStart(LLVMModuleRef module);
-LLVMValueRef LLVMLifetimeEnd(LLVMModuleRef module);
+LLVMValueRef LLVMLifetimeStart(LLVMModuleRef module, LLVMTypeRef type);
+LLVMValueRef LLVMLifetimeEnd(LLVMModuleRef module, LLVMTypeRef type);
 
 #if PONY_LLVM >= 309
 #define LLVM_DECLARE_ATTRIBUTEREF(decl, name, val) \
@@ -184,8 +186,10 @@ typedef struct compile_t
   LLVMDIBuilderRef di;
   LLVMMetadataRef di_unit;
   LLVMValueRef tbaa_root;
+#if LLVM_PONY < 400
   LLVMValueRef tbaa_descriptor;
   LLVMValueRef tbaa_descptr;
+#endif  
   LLVMValueRef none_instance;
   LLVMValueRef primitives_init;
   LLVMValueRef primitives_final;
diff --git a/src/libponyc/codegen/genbox.c b/src/libponyc/codegen/genbox.c
index b4fbe7ef3f..a294f61a8d 100644
--- a/src/libponyc/codegen/genbox.c
+++ b/src/libponyc/codegen/genbox.c
@@ -31,8 +31,12 @@ LLVMValueRef gen_box(compile_t* c, ast_t* type, LLVMValueRef value)
 
   const char* box_name = genname_box(t->name);
   LLVMValueRef metadata = tbaa_metadata_for_box_type(c, box_name);
+#if PONY_LLVM >= 400
+  tbaa_tag(c, metadata, store);
+#else
   const char id[] = "tbaa";
   LLVMSetMetadata(store, LLVMGetMDKindID(id, sizeof(id) - 1), metadata);
+#endif
 
   return this_ptr;
 }
@@ -60,8 +64,12 @@ LLVMValueRef gen_unbox(compile_t* c, ast_t* type, LLVMValueRef object)
 
   const char* box_name = genname_box(t->name);
   LLVMValueRef metadata = tbaa_metadata_for_box_type(c, box_name);
+#if PONY_LLVM >= 400
+  tbaa_tag(c, metadata, value);
+#else
   const char id[] = "tbaa";
   LLVMSetMetadata(value, LLVMGetMDKindID(id, sizeof(id) - 1), metadata);
+#endif
 
   return gen_assign_cast(c, c_t->use_type, value, t->ast_cap);
 }
diff --git a/src/libponyc/codegen/gencall.c b/src/libponyc/codegen/gencall.c
index d29fbe3841..7632e7b204 100644
--- a/src/libponyc/codegen/gencall.c
+++ b/src/libponyc/codegen/gencall.c
@@ -331,8 +331,12 @@ static void set_descriptor(compile_t* c, reach_type_t* t, LLVMValueRef value)
   LLVMValueRef desc_ptr = LLVMBuildStructGEP(c->builder, value, 0, "");
   LLVMValueRef store = LLVMBuildStore(c->builder,
     ((compile_type_t*)t->c_type)->desc, desc_ptr);
+#if PONY_LLVM >= 400
+  tbaa_tag(c, c->tbaa_descptr, store);
+#else
   const char id[] = "tbaa";
   LLVMSetMetadata(store, LLVMGetMDKindID(id, sizeof(id) - 1), c->tbaa_descptr);
+#endif
 }
 
 // This function builds a stack of indices such that for an AST nested in an
@@ -1396,7 +1400,7 @@ void gencall_memmove(compile_t* c, LLVMValueRef dst, LLVMValueRef src,
 
 void gencall_lifetime_start(compile_t* c, LLVMValueRef ptr)
 {
-  LLVMValueRef func = LLVMLifetimeStart(c->module);
+  LLVMValueRef func = LLVMLifetimeStart(c->module, c->void_ptr);
   LLVMTypeRef type = LLVMGetElementType(LLVMTypeOf(ptr));
   size_t size = (size_t)LLVMABISizeOfType(c->target_data, type);
 
@@ -1408,7 +1412,7 @@ void gencall_lifetime_start(compile_t* c, LLVMValueRef ptr)
 
 void gencall_lifetime_end(compile_t* c, LLVMValueRef ptr)
 {
-  LLVMValueRef func = LLVMLifetimeEnd(c->module);
+  LLVMValueRef func = LLVMLifetimeEnd(c->module, c->void_ptr);
   LLVMTypeRef type = LLVMGetElementType(LLVMTypeOf(ptr));
   size_t size = (size_t)LLVMABISizeOfType(c->target_data, type);
 
diff --git a/src/libponyc/codegen/gendebug.cc b/src/libponyc/codegen/gendebug.cc
index cd55089e77..4ab95a8194 100644
--- a/src/libponyc/codegen/gendebug.cc
+++ b/src/libponyc/codegen/gendebug.cc
@@ -22,17 +22,21 @@
 
 namespace llvm
 {
+#if PONY_LLVM < 500
   DEFINE_ISA_CONVERSION_FUNCTIONS(Metadata, LLVMMetadataRef)
 
   inline Metadata** unwrap(LLVMMetadataRef* md)
   {
     return reinterpret_cast<Metadata**>(md);
   }
+  #endif
 }
 
 using namespace llvm;
 
+#if PONY_LLVM < 500
 DEFINE_SIMPLE_CONVERSION_FUNCTIONS(DIBuilder, LLVMDIBuilderRef);
+#endif
 
 void LLVMMetadataReplaceAllUsesWith(LLVMMetadataRef md_old,
   LLVMMetadataRef md_new)
@@ -69,16 +73,20 @@ LLVMMetadataRef LLVMDIBuilderCreateCompileUnit(LLVMDIBuilderRef d,
   unsigned lang, const char* file, const char* dir, const char* producer,
   int optimized)
 {
-#if PONY_LLVM >= 309
   DIBuilder* pd = unwrap(d);
-
+  const StringRef flags = "";
+  const unsigned runtimever = 0;
+
+#if PONY_LLVM >= 400
+  DIFile* difile = pd->createFile(file, dir);
+  return wrap(pd->createCompileUnit(lang, difile, producer,
+    optimized ? true : false, flags, runtimever));
+#elif PONY_LLVM >= 309
   return wrap(pd->createCompileUnit(lang, file, dir, producer, optimized,
-    StringRef(), 0, StringRef())); // use the defaults
+    flags, runtimever, StringRef())); // use the defaults
 #else
-  DIBuilder* pd = unwrap(d);
-
   return wrap(pd->createCompileUnit(lang, file, dir, producer, optimized,
-    StringRef(), 0, StringRef(), DIBuilder::FullDebug, 0, true));
+    flags, runtimever, StringRef(), DIBuilder::FullDebug, 0, true));
 #endif
 }
 
@@ -106,26 +114,31 @@ LLVMMetadataRef LLVMDIBuilderCreateMethod(LLVMDIBuilderRef d,
   LLVMMetadataRef file, unsigned line, LLVMMetadataRef type, LLVMValueRef func,
   int optimized)
 {
-#if PONY_LLVM >= 308
   DIBuilder* pd = unwrap(d);
   Function* f = unwrap<Function>(func);
 
+#if PONY_LLVM >= 400
   DISubprogram* di_method = pd->createMethod(unwrap<DIScope>(scope),
     name, linkage, unwrap<DIFile>(file), line, unwrap<DISubroutineType>(type),
-    false, true, 0, 0,
-#  if PONY_LLVM >= 309
-    0,
-#  else
-    nullptr,
-#  endif
-    0, optimized);
+    false, true, 0, 0, 0, nullptr, DINode::FlagZero, optimized ? true : false);
 
   f->setSubprogram(di_method);
   return wrap(di_method);
-#else
-  DIBuilder* pd = unwrap(d);
-  Function* f = unwrap<Function>(func);
+#elif PONY_LLVM >= 309
+  DISubprogram* di_method = pd->createMethod(unwrap<DIScope>(scope),
+    name, linkage, unwrap<DIFile>(file), line, unwrap<DISubroutineType>(type),
+    false, true, 0, 0, 0, 0, optimized);
 
+  f->setSubprogram(di_method);
+  return wrap(di_method);
+#elif PONY_LLVM >= 308
+  DISubprogram* di_method = pd->createMethod(unwrap<DIScope>(scope),
+    name, linkage, unwrap<DIFile>(file), line, unwrap<DISubroutineType>(type),
+    false, true, 0, 0, nullptr, 0, optimized);
+
+  f->setSubprogram(di_method);
+  return wrap(di_method);
+#else
   return wrap(pd->createMethod(unwrap<DIScope>(scope), name, linkage,
     unwrap<DIFile>(file), line, unwrap<DISubroutineType>(type),
     false, true, 0, 0, nullptr, 0, optimized, f));
@@ -136,14 +149,15 @@ LLVMMetadataRef LLVMDIBuilderCreateAutoVariable(LLVMDIBuilderRef d,
   LLVMMetadataRef scope, const char* name, LLVMMetadataRef file,
   unsigned line, LLVMMetadataRef type)
 {
-#if PONY_LLVM >= 308
   DIBuilder* pd = unwrap(d);
 
+#if PONY_LLVM >= 400
+  return wrap(pd->createAutoVariable(unwrap<DIScope>(scope), name,
+    unwrap<DIFile>(file), line, unwrap<DIType>(type), true, DINode::FlagZero));
+#elif PONY_LLVM >= 308
   return wrap(pd->createAutoVariable(unwrap<DIScope>(scope), name,
     unwrap<DIFile>(file), line, unwrap<DIType>(type), true, 0));
 #else
-  DIBuilder* pd = unwrap(d);
-
   return wrap(pd->createLocalVariable(DW_TAG_auto_variable,
     unwrap<DIScope>(scope), name, unwrap<DIFile>(file), line,
     unwrap<DIType>(type), true, 0));
@@ -154,15 +168,17 @@ LLVMMetadataRef LLVMDIBuilderCreateParameterVariable(LLVMDIBuilderRef d,
   LLVMMetadataRef scope, const char* name, unsigned arg,
   LLVMMetadataRef file, unsigned line, LLVMMetadataRef type)
 {
-#if PONY_LLVM >= 308
   DIBuilder* pd = unwrap(d);
 
+#if PONY_LLVM >= 400
+  return wrap(pd->createParameterVariable(
+    unwrap<DIScope>(scope), name, arg, unwrap<DIFile>(file), line,
+    unwrap<DIType>(type), true, DINode::FlagZero));
+#elif PONY_LLVM >= 308
   return wrap(pd->createParameterVariable(
     unwrap<DIScope>(scope), name, arg, unwrap<DIFile>(file), line,
     unwrap<DIType>(type), true, 0));
 #else
-  DIBuilder* pd = unwrap(d);
-
   return wrap(pd->createLocalVariable(DW_TAG_arg_variable,
     unwrap<DIScope>(scope), name, unwrap<DIFile>(file), line,
     unwrap<DIType>(type), true, 0, arg));
@@ -195,7 +211,13 @@ LLVMMetadataRef LLVMDIBuilderCreateBasicType(LLVMDIBuilderRef d,
   unsigned encoding)
 {
   DIBuilder* pd = unwrap(d);
+
+#if PONY_LLVM >= 400
+  (void)(align_bits);
+  return wrap(pd->createBasicType(name, size_bits, encoding));
+#else
   return wrap(pd->createBasicType(name, size_bits, align_bits, encoding));
+#endif
 }
 
 LLVMMetadataRef LLVMDIBuilderCreatePointerType(LLVMDIBuilderRef d,
@@ -204,7 +226,7 @@ LLVMMetadataRef LLVMDIBuilderCreatePointerType(LLVMDIBuilderRef d,
   DIBuilder* pd = unwrap(d);
 
   return wrap(pd->createPointerType(unwrap<DIType>(elem_type), size_bits,
-    align_bits));
+    static_cast<uint32_t>(align_bits)));
 }
 
 LLVMMetadataRef LLVMDIBuilderCreateSubroutineType(LLVMDIBuilderRef d,
@@ -231,9 +253,16 @@ LLVMMetadataRef LLVMDIBuilderCreateStructType(LLVMDIBuilderRef d,
 {
   DIBuilder* pd = unwrap(d);
 
+#if PONY_LLVM >= 400
+  return wrap(pd->createStructType(unwrap<DIScope>(scope), name,
+    unwrap<DIFile>(file), line, size_bits,
+    static_cast<uint32_t>(align_bits), DINode::FlagZero, nullptr,
+    elem_types ? DINodeArray(unwrap<MDTuple>(elem_types)) : nullptr));
+#else
   return wrap(pd->createStructType(unwrap<DIScope>(scope), name,
     unwrap<DIFile>(file), line, size_bits, align_bits, 0, nullptr,
     elem_types ? DINodeArray(unwrap<MDTuple>(elem_types)) : nullptr));
+#endif
 }
 
 LLVMMetadataRef LLVMDIBuilderCreateReplaceableStruct(LLVMDIBuilderRef d,
@@ -252,9 +281,16 @@ LLVMMetadataRef LLVMDIBuilderCreateMemberType(LLVMDIBuilderRef d,
 {
   DIBuilder* pd = unwrap(d);
 
+#if PONY_LLVM >= 400
+  return wrap(pd->createMemberType(unwrap<DIScope>(scope), name,
+    unwrap<DIFile>(file), line, size_bits, static_cast<uint32_t>(align_bits),
+    offset_bits, flags ? DINode::FlagPrivate : DINode::FlagZero,
+    unwrap<DIType>(type)));
+#else
   return wrap(pd->createMemberType(unwrap<DIScope>(scope), name,
     unwrap<DIFile>(file), line, size_bits, align_bits,
     offset_bits, flags, unwrap<DIType>(type)));
+#endif
 }
 
 LLVMMetadataRef LLVMDIBuilderCreateArrayType(LLVMDIBuilderRef d,
@@ -263,7 +299,7 @@ LLVMMetadataRef LLVMDIBuilderCreateArrayType(LLVMDIBuilderRef d,
 {
   DIBuilder* pd = unwrap(d);
 
-  return wrap(pd->createArrayType(size_bits, align_bits,
+  return wrap(pd->createArrayType(size_bits, static_cast<uint32_t>(align_bits),
     unwrap<DIType>(elem_type), DINodeArray(unwrap<MDTuple>(subscripts))));
 }
 
diff --git a/src/libponyc/codegen/gendesc.c b/src/libponyc/codegen/gendesc.c
index b0994f9516..a7080d8ef8 100644
--- a/src/libponyc/codegen/gendesc.c
+++ b/src/libponyc/codegen/gendesc.c
@@ -44,7 +44,6 @@ static LLVMValueRef make_unbox_function(compile_t* c, reach_type_t* t,
   LLVMGetParamTypes(f_type, params);
   LLVMTypeRef ret_type = LLVMGetReturnType(f_type);
 
-  const char* box_name = genname_box(t->name);
   const char* unbox_name = genname_unbox(m->full_name);
   compile_type_t* c_t = (compile_type_t*)t->c_type;
 
@@ -70,9 +69,14 @@ static LLVMValueRef make_unbox_function(compile_t* c, reach_type_t* t,
   LLVMValueRef primitive_ptr = LLVMBuildStructGEP(c->builder, this_ptr, 1, "");
   LLVMValueRef primitive = LLVMBuildLoad(c->builder, primitive_ptr, "");
 
+  const char* box_name = genname_box(t->name);
   LLVMValueRef metadata = tbaa_metadata_for_box_type(c, box_name);
+#if PONY_LLVM >= 400
+  tbaa_tag(c, metadata, primitive);
+#else
   const char id[] = "tbaa";
   LLVMSetMetadata(primitive, LLVMGetMDKindID(id, sizeof(id) - 1), metadata);
+#endif
 
   primitive = gen_assign_cast(c, c_t->use_type, primitive, t->ast_cap);
 
@@ -414,7 +418,6 @@ void gendesc_init(compile_t* c, reach_type_t* t)
   uint32_t event_notify_index = reach_vtable_index(t, c->str__event_notify);
 
   LLVMValueRef args[DESC_LENGTH];
-
   args[DESC_ID] = LLVMConstInt(c->i32, t->type_id, false);
   args[DESC_SIZE] = LLVMConstInt(c->i32, c_t->abi_size, false);
   args[DESC_FIELD_COUNT] = make_field_count(c, t);
@@ -506,9 +509,13 @@ static LLVMValueRef desc_field(compile_t* c, LLVMValueRef desc, int index)
 {
   LLVMValueRef ptr = LLVMBuildStructGEP(c->builder, desc, index, "");
   LLVMValueRef field = LLVMBuildLoad(c->builder, ptr, "");
+#if PONY_LLVM >= 400
+  tbaa_tag(c, c->tbaa_descriptor, field);
+#else
   const char id[] = "tbaa";
   LLVMSetMetadata(field, LLVMGetMDKindID(id, sizeof(id) - 1),
     c->tbaa_descriptor);
+#endif
   return field;
 }
 
@@ -516,8 +523,12 @@ LLVMValueRef gendesc_fetch(compile_t* c, LLVMValueRef object)
 {
   LLVMValueRef ptr = LLVMBuildStructGEP(c->builder, object, 0, "");
   LLVMValueRef desc = LLVMBuildLoad(c->builder, ptr, "");
+#if PONY_LLVM >= 400
+  tbaa_tag(c, c->tbaa_descptr, desc);
+#else
   const char id[] = "tbaa";
   LLVMSetMetadata(desc, LLVMGetMDKindID(id, sizeof(id) - 1), c->tbaa_descptr);
+#endif
   return desc;
 }
 
@@ -551,8 +562,12 @@ LLVMValueRef gendesc_vtable(compile_t* c, LLVMValueRef desc, size_t colour)
 
   LLVMValueRef func_ptr = LLVMBuildInBoundsGEP(c->builder, vtable, gep, 2, "");
   LLVMValueRef fun = LLVMBuildLoad(c->builder, func_ptr, "");
+#if PONY_LLVM >= 400
+  tbaa_tag(c, c->tbaa_descriptor, fun);
+#else
   const char id[] = "tbaa";
   LLVMSetMetadata(fun, LLVMGetMDKindID(id, sizeof(id) - 1), c->tbaa_descriptor);
+#endif
   return fun;
 }
 
@@ -583,9 +598,13 @@ LLVMValueRef gendesc_fieldinfo(compile_t* c, LLVMValueRef desc, size_t index)
   LLVMValueRef field_desc = LLVMBuildInBoundsGEP(c->builder, fields, gep, 2,
     "");
   LLVMValueRef field_info = LLVMBuildLoad(c->builder, field_desc, "");
+#if PONY_LLVM >= 400
+  tbaa_tag(c, c->tbaa_descriptor, field_info);
+#else
   const char id[] = "tbaa";
   LLVMSetMetadata(field_info, LLVMGetMDKindID(id, sizeof(id) - 1),
     c->tbaa_descriptor);
+#endif
   return field_info;
 }
 
@@ -670,9 +689,13 @@ LLVMValueRef gendesc_istrait(compile_t* c, LLVMValueRef desc, ast_t* type)
   LLVMValueRef index = LLVMBuildInBoundsGEP(c->builder, bitmap, args, 2, "");
   index = LLVMBuildLoad(c->builder, index, "");
 
+#if PONY_LLVM >= 400
+  tbaa_tag(c, c->tbaa_descriptor, index);
+#else
   const char id[] = "tbaa";
   LLVMSetMetadata(index, LLVMGetMDKindID(id, sizeof(id) - 1),
     c->tbaa_descriptor);
+#endif
 
   LLVMValueRef has_trait = LLVMBuildAnd(c->builder, index, mask, "");
   has_trait = LLVMBuildICmp(c->builder, LLVMIntNE, has_trait,
diff --git a/src/libponyc/codegen/genexpr.c b/src/libponyc/codegen/genexpr.c
index 06d7aaae0e..543295035e 100644
--- a/src/libponyc/codegen/genexpr.c
+++ b/src/libponyc/codegen/genexpr.c
@@ -32,8 +32,10 @@ LLVMValueRef gen_expr(compile_t* c, ast_t* ast)
       break;
 
     case TK_TUPLEELEMREF:
+    {
       ret = gen_tupleelemptr(c, ast);
       break;
+    }
 
     case TK_EMBEDREF:
       ret = gen_fieldembed(c, ast);
diff --git a/src/libponyc/codegen/genoperator.c b/src/libponyc/codegen/genoperator.c
index 9ff2a44dd7..8dfa531c24 100644
--- a/src/libponyc/codegen/genoperator.c
+++ b/src/libponyc/codegen/genoperator.c
@@ -359,11 +359,17 @@ static LLVMValueRef assign_field(compile_t* c, LLVMValueRef l_value,
 
   // Store to the field.
   LLVMValueRef store = LLVMBuildStore(c->builder, r_value, l_value);
-
   LLVMValueRef metadata = tbaa_metadata_for_type(c, p_type);
+
+#if PONY_LLVM >= 400
+  tbaa_tag(c, metadata, result);
+  tbaa_tag(c, metadata, store);
+#else
   const char id[] = "tbaa";
-  LLVMSetMetadata(result, LLVMGetMDKindID(id, sizeof(id) - 1), metadata);
-  LLVMSetMetadata(store, LLVMGetMDKindID(id, sizeof(id) - 1), metadata);
+  unsigned md_kind = LLVMGetMDKindID(id, sizeof(id) - 1);
+  LLVMSetMetadata(result, md_kind, metadata);
+  LLVMSetMetadata(store, md_kind, metadata);
+#endif
 
   return gen_assign_cast(c, c_t->use_type, result, l_type);
 }
diff --git a/src/libponyc/codegen/genopt.cc b/src/libponyc/codegen/genopt.cc
index 41d390f31d..d238f1d779 100644
--- a/src/libponyc/codegen/genopt.cc
+++ b/src/libponyc/codegen/genopt.cc
@@ -21,6 +21,8 @@
 #include <llvm/IR/DebugInfo.h>
 
 #include <llvm/IR/LegacyPassManager.h>
+#include <llvm/Analysis/CallGraph.h>
+#include <llvm/Analysis/Lint.h>
 #include <llvm/Analysis/TargetLibraryInfo.h>
 #include <llvm/Analysis/TargetTransformInfo.h>
 
@@ -110,7 +112,7 @@ class HeapToStack : public FunctionPass
       {
         Instruction* inst = &(*(iter++));
 
-        if(runOnInstruction(builder, inst, dt))
+        if(runOnInstruction(builder, inst, dt, f))
           changed = true;
       }
     }
@@ -119,7 +121,7 @@ class HeapToStack : public FunctionPass
   }
 
   bool runOnInstruction(IRBuilder<>& builder, Instruction* inst,
-    DominatorTree& dt)
+    DominatorTree& dt, Function& f)
   {
     CallSite call(inst);
 
@@ -179,11 +181,33 @@ class HeapToStack : public FunctionPass
     // TODO: for variable size alloca, don't insert at the beginning.
     Instruction* begin = &(*call.getCaller()->getEntryBlock().begin());
 
+#if PONY_LLVM < 500
     AllocaInst* replace = new AllocaInst(builder.getInt8Ty(), int_size, "",
       begin);
+#else
+    AllocaInst* replace = new AllocaInst(builder.getInt8Ty(),
+      (unsigned int)int_size->getZExtValue(), "", begin);
+#endif
 
     replace->setDebugLoc(call->getDebugLoc());
     inst->replaceAllUsesWith(replace);
+
+#if PONY_LLVM >= 400
+    if (call.isInvoke())
+    {
+      InvokeInst *invoke = cast<InvokeInst>(call.getInstruction());
+      BranchInst::Create(invoke->getNormalDest(), invoke);
+      invoke->getUnwindDest()->removePredecessor(call->getParent());
+    }
+    CallGraphWrapperPass *cg_pass =
+      getAnalysisIfAvailable<CallGraphWrapperPass>();
+    CallGraph *cg = cg_pass ? &cg_pass->getCallGraph() : nullptr;
+    CallGraphNode *cg_node = cg ? (*cg)[&f] : nullptr;
+    if (cg_node)
+    {
+      cg_node->removeCallEdgeFor(call);
+    }
+#endif
     inst->eraseFromParent();
 
     for(auto new_call: new_calls)
@@ -511,7 +535,7 @@ class DispatchPonyCtx : public FunctionPass
   }
 };
 
-char DispatchPonyCtx::ID = 0;
+char DispatchPonyCtx::ID = 1;
 
 static RegisterPass<DispatchPonyCtx>
   DPC("dispatchponyctx", "Replace pony_ctx calls in a dispatch function by the\
@@ -826,23 +850,38 @@ class MergeRealloc : public FunctionPass
       ArrayRef<Type*>(params, 2), false);
     Function* fn = Function::Create(fn_type, Function::ExternalLinkage, name,
       &m);
-    fn->addAttribute(AttributeSet::FunctionIndex, Attribute::NoUnwind);
+
+#if PONY_LLVM < 500
+    unsigned functionIndex = AttributeSet::FunctionIndex;
+    unsigned returnIndex = AttributeSet::ReturnIndex;
+#else
+    unsigned functionIndex = AttributeList::FunctionIndex;
+    unsigned returnIndex = AttributeList::ReturnIndex;
+#endif
+
+    fn->addAttribute(functionIndex, Attribute::NoUnwind);
 #if PONY_LLVM >= 308
-    fn->addAttribute(AttributeSet::FunctionIndex,
+    fn->addAttribute(functionIndex,
       Attribute::InaccessibleMemOrArgMemOnly);
 #endif
+
+#if PONY_LLVM < 500
     fn->setDoesNotAlias(0);
+#endif
 
     if(can_be_null)
-      fn->addDereferenceableOrNullAttr(AttributeSet::ReturnIndex, min_size);
+      fn->addDereferenceableOrNullAttr(returnIndex, min_size);
     else
-      fn->addDereferenceableAttr(AttributeSet::ReturnIndex, min_size);
+      fn->addDereferenceableAttr(returnIndex, min_size);
 
     AttrBuilder attr;
     attr.addAlignmentAttr(32);
-    unsigned index = AttributeSet::ReturnIndex;
-    fn->addAttributes(index, AttributeSet::get(m.getContext(), index, attr));
-
+#if PONY_LLVM < 500
+    fn->addAttributes(returnIndex, AttributeSet::get(m.getContext(),
+      returnIndex, attr));
+#else
+    fn->addAttributes(returnIndex, AttributeSet::get(m.getContext(), attr));
+#endif
     return fn;
   }
 
@@ -860,7 +899,7 @@ class MergeRealloc : public FunctionPass
   }
 };
 
-char MergeRealloc::ID = 0;
+char MergeRealloc::ID = 2;
 
 static RegisterPass<MergeRealloc>
   MR("mergerealloc", "Merge successive reallocations of the same variable");
@@ -1226,7 +1265,14 @@ class MergeMessageSend : public BasicBlockPass
       {unwrap(c->void_ptr)}, false);
     Function* fn = Function::Create(fn_type, Function::ExternalLinkage,
       "pony_send_next", &m);
-    fn->addAttribute(AttributeSet::FunctionIndex, Attribute::NoUnwind);
+
+#if PONY_LLVM < 500
+    unsigned functionIndex = AttributeSet::FunctionIndex;
+#else
+    unsigned functionIndex = AttributeList::FunctionIndex;
+#endif
+
+    fn->addAttribute(functionIndex, Attribute::NoUnwind);
     return fn;
   }
 
@@ -1236,15 +1282,22 @@ class MergeMessageSend : public BasicBlockPass
       {unwrap(c->msg_ptr), unwrap(c->msg_ptr)}, false);
     Function* fn = Function::Create(fn_type, Function::ExternalLinkage,
       "pony_chain", &m);
-    fn->addAttribute(AttributeSet::FunctionIndex, Attribute::NoUnwind);
-    fn->addAttribute(AttributeSet::FunctionIndex, Attribute::ArgMemOnly);
+
+#if PONY_LLVM < 500
+    unsigned functionIndex = AttributeSet::FunctionIndex;
+#else
+    unsigned functionIndex = AttributeList::FunctionIndex;
+#endif
+
+    fn->addAttribute(functionIndex, Attribute::NoUnwind);
+    fn->addAttribute(functionIndex, Attribute::ArgMemOnly);
     fn->addAttribute(1, Attribute::NoCapture);
     fn->addAttribute(2, Attribute::ReadNone);
     return fn;
   }
 };
 
-char MergeMessageSend::ID = 0;
+char MergeMessageSend::ID = 3;
 
 static RegisterPass<MergeMessageSend>
   MMS("mergemessagesend", "Group message sends in the same BasicBlock");
@@ -1297,7 +1350,9 @@ static void optimise(compile_t* c, bool pony_specific)
   pmb.LoopVectorize = true;
   pmb.SLPVectorize = true;
   pmb.RerollLoops = true;
+#if PONY_LLVM < 500
   pmb.LoadCombine = true;
+#endif
 
   if(pony_specific)
   {
@@ -1346,6 +1401,9 @@ static void optimise(compile_t* c, bool pony_specific)
   if(c->opt->strip_debug)
     lpm.add(createStripSymbolsPass());
 
+  if(c->opt->lint_llvm)
+    fpm.add(createLintPass());
+
   fpm.doInitialization();
 
   for(Module::iterator f = m->begin(), end = m->end(); f != end; ++f)
@@ -1441,7 +1499,11 @@ bool target_is_x86(char* t)
 {
   Triple triple = Triple(t);
 
+#if PONY_LLVM >= 400
+  const char* arch = Triple::getArchTypePrefix(triple.getArch()).data();
+#else
   const char* arch = Triple::getArchTypePrefix(triple.getArch());
+#endif
 
   return !strcmp("x86", arch);
 }
@@ -1450,7 +1512,11 @@ bool target_is_arm(char* t)
 {
   Triple triple = Triple(t);
 
+#if PONY_LLVM >= 400
+  const char* arch = Triple::getArchTypePrefix(triple.getArch()).data();
+#else
   const char* arch = Triple::getArchTypePrefix(triple.getArch());
+#endif
 
   return !strcmp("arm", arch);
 }
diff --git a/src/libponyc/codegen/genprim.c b/src/libponyc/codegen/genprim.c
index d1fbe5423b..8b8887c80e 100644
--- a/src/libponyc/codegen/genprim.c
+++ b/src/libponyc/codegen/genprim.c
@@ -216,8 +216,12 @@ static void pointer_apply(compile_t* c, void* data, token_id cap)
   ast_setid(tcap, cap);
 
   LLVMValueRef metadata = tbaa_metadata_for_type(c, t->ast);
+#if PONY_LLVM >= 400
+  tbaa_tag(c, metadata, result);
+#else
   const char id[] = "tbaa";
   LLVMSetMetadata(result, LLVMGetMDKindID(id, sizeof(id) - 1), metadata);
+#endif
 
   ast_setid(tcap, tmp_cap);
 
@@ -252,9 +256,14 @@ static void pointer_update(compile_t* c, reach_type_t* t,
   LLVMValueRef store = LLVMBuildStore(c->builder, value, loc);
 
   LLVMValueRef metadata = tbaa_metadata_for_type(c, t->ast);
+#if PONY_LLVM >= 400
+  tbaa_tag(c, metadata, result);
+  tbaa_tag(c, metadata, store);
+#else
   const char id[] = "tbaa";
   LLVMSetMetadata(result, LLVMGetMDKindID(id, sizeof(id) - 1), metadata);
   LLVMSetMetadata(store, LLVMGetMDKindID(id, sizeof(id) - 1), metadata);
+#endif
 
   result = gen_assign_cast(c, c_t_elem->use_type, result, t_elem->ast_cap);
   LLVMBuildRet(c->builder, result);
@@ -358,8 +367,12 @@ static void pointer_delete(compile_t* c, reach_type_t* t,
   LLVMValueRef result = LLVMBuildLoad(c->builder, elem_ptr, "");
 
   LLVMValueRef metadata = tbaa_metadata_for_type(c, t->ast);
+#if PONY_LLVM >= 400
+  tbaa_tag(c, metadata, result);
+#else
   const char id[] = "tbaa";
   LLVMSetMetadata(result, LLVMGetMDKindID(id, sizeof(id) - 1), metadata);
+#endif
 
   LLVMValueRef src = LLVMBuildInBoundsGEP(c->builder, elem_ptr, &n, 1, "");
   src = LLVMBuildBitCast(c->builder, src, c_t->use_type, "");
diff --git a/src/libponyc/codegen/genreference.c b/src/libponyc/codegen/genreference.c
index 7c5c9792fa..fe97f316f9 100644
--- a/src/libponyc/codegen/genreference.c
+++ b/src/libponyc/codegen/genreference.c
@@ -63,9 +63,10 @@ static LLVMValueRef make_fieldptr(compile_t* c, LLVMValueRef l_value,
   pony_assert(ast_id(l_type) == TK_NOMINAL);
   pony_assert(ast_id(right) == TK_ID);
 
-  ast_t* def = (ast_t*)ast_data(l_type);
-  ast_t* field = ast_get(def, ast_name(right), NULL);
-  int index = (int)ast_index(field);
+  ast_t* def;
+  ast_t* field;
+  uint32_t index;
+  get_fieldinfo(l_type, right, &def, &field, &index);
 
   if(ast_id(def) != TK_STRUCT)
     index++;
@@ -104,9 +105,14 @@ LLVMValueRef gen_fieldload(compile_t* c, ast_t* ast)
   compile_type_t* c_t = (compile_type_t*)t->c_type;
 
   field = LLVMBuildLoad(c->builder, field, "");
+
   LLVMValueRef metadata = tbaa_metadata_for_type(c, ast_type(left));
+#if PONY_LLVM >= 400
+  tbaa_tag(c, metadata, field);
+#else
   const char id[] = "tbaa";
   LLVMSetMetadata(field, LLVMGetMDKindID(id, sizeof(id) - 1), metadata);
+#endif
 
   return gen_assign_cast(c, c_t->use_type, field, type);
 }
diff --git a/src/libponyc/codegen/gentype.c b/src/libponyc/codegen/gentype.c
index b20d4036e7..0707b2fc57 100644
--- a/src/libponyc/codegen/gentype.c
+++ b/src/libponyc/codegen/gentype.c
@@ -19,11 +19,6 @@
 #include <stdlib.h>
 #include <string.h>
 
-static void compile_type_free(void* p)
-{
-  POOL_FREE(compile_type_t, p);
-}
-
 static size_t tbaa_metadata_hash(tbaa_metadata_t* a)
 {
   return ponyint_hash_ptr(a->name);
@@ -116,6 +111,32 @@ LLVMValueRef tbaa_metadata_for_box_type(compile_t* c, const char* box_name)
   return md->metadata;
 }
 
+void tbaa_tag(compile_t* c, LLVMValueRef metadata, LLVMValueRef instr)
+{
+  const char id[] = "tbaa";
+  unsigned md_kind = LLVMGetMDKindID(id, sizeof(id) - 1);
+
+  LLVMValueRef params[3];
+  params[0] = metadata;
+  params[1] = metadata;
+  params[2] = LLVMConstInt(c->i32, 0, false);
+
+  LLVMValueRef tag = LLVMMDNodeInContext(c->context, params, 3);
+  LLVMSetMetadata(instr, md_kind, tag);
+}
+
+void get_fieldinfo(ast_t* l_type, ast_t* right, ast_t** l_def,
+  ast_t** field, uint32_t* index)
+{
+  ast_t* d = (ast_t*)ast_data(l_type);
+  ast_t* f = ast_get(d, ast_name(right), NULL);
+  uint32_t i = (uint32_t)ast_index(f);
+
+  *l_def = d;
+  *field = f;
+  *index = i;
+}
+
 static LLVMValueRef make_tbaa_root(LLVMContextRef ctx)
 {
   const char str[] = "Pony TBAA";
@@ -142,6 +163,11 @@ static LLVMValueRef make_tbaa_descptr(LLVMContextRef ctx, LLVMValueRef root)
   return LLVMMDNodeInContext(ctx, params, 2);
 }
 
+static void compile_type_free(void* p)
+{
+  POOL_FREE(compile_type_t, p);
+}
+
 static void allocate_compile_types(compile_t* c)
 {
   size_t i = HASHMAP_BEGIN;
@@ -807,6 +833,7 @@ bool gentypes(compile_t* c)
     c->trait_bitmap_size = ((c->reach->trait_type_count + 63) & ~63) >> 6;
 
   c->tbaa_root = make_tbaa_root(c->context);
+
   c->tbaa_descriptor = make_tbaa_descriptor(c->context, c->tbaa_root);
   c->tbaa_descptr = make_tbaa_descptr(c->context, c->tbaa_root);
 
diff --git a/src/libponyc/codegen/gentype.h b/src/libponyc/codegen/gentype.h
index e35d89c26f..5604082972 100644
--- a/src/libponyc/codegen/gentype.h
+++ b/src/libponyc/codegen/gentype.h
@@ -6,6 +6,27 @@
 
 PONY_EXTERN_C_BEGIN
 
+typedef struct tbaa_metadata_t
+{
+  const char* name;
+  LLVMValueRef metadata;
+} tbaa_metadata_t;
+
+DECLARE_HASHMAP(tbaa_metadatas, tbaa_metadatas_t, tbaa_metadata_t);
+
+tbaa_metadatas_t* tbaa_metadatas_new();
+
+void tbaa_metadatas_free(tbaa_metadatas_t* tbaa_metadatas);
+
+LLVMValueRef tbaa_metadata_for_type(compile_t* c, ast_t* type);
+
+LLVMValueRef tbaa_metadata_for_box_type(compile_t* c, const char* box_name);
+
+void tbaa_tag(compile_t* c, LLVMValueRef metadata, LLVMValueRef instr);
+
+void get_fieldinfo(ast_t* l_type, ast_t* right, ast_t** l_def,
+  ast_t** field, uint32_t* index);
+
 typedef struct compile_type_t
 {
   compile_opaque_free_fn free_fn;
@@ -37,22 +58,6 @@ typedef struct compile_type_t
   LLVMMetadataRef di_type_embed;
 } compile_type_t;
 
-typedef struct tbaa_metadata_t
-{
-  const char* name;
-  LLVMValueRef metadata;
-} tbaa_metadata_t;
-
-DECLARE_HASHMAP(tbaa_metadatas, tbaa_metadatas_t, tbaa_metadata_t);
-
-tbaa_metadatas_t* tbaa_metadatas_new();
-
-void tbaa_metadatas_free(tbaa_metadatas_t* tbaa_metadatas);
-
-LLVMValueRef tbaa_metadata_for_type(compile_t* c, ast_t* type);
-
-LLVMValueRef tbaa_metadata_for_box_type(compile_t* c, const char* box_name);
-
 bool gentypes(compile_t* c);
 
 PONY_EXTERN_C_END
diff --git a/src/libponyc/codegen/host.cc b/src/libponyc/codegen/host.cc
index 45929d9a57..b397736e25 100644
--- a/src/libponyc/codegen/host.cc
+++ b/src/libponyc/codegen/host.cc
@@ -222,6 +222,17 @@ void LLVMSetMetadataStr(LLVMValueRef val, const char* str, LLVMValueRef node)
     cast<Function>(v)->setMetadata(str, n);
 }
 
+void LLVMMDNodeReplaceOperand(LLVMValueRef parent, unsigned i,
+  LLVMValueRef node)
+{
+  pony_assert(parent != NULL);
+  pony_assert(node != NULL);
+
+  MDNode *pn = extractMDNode(unwrap<MetadataAsValue>(parent));
+  MDNode *cn = extractMDNode(unwrap<MetadataAsValue>(node));
+  pn->replaceOperandWith(i, cn);
+}
+
 LLVMValueRef LLVMMemcpy(LLVMModuleRef module, bool ilp32)
 {
   Module* m = unwrap(module);
@@ -246,16 +257,26 @@ LLVMValueRef LLVMMemmove(LLVMModuleRef module, bool ilp32)
   return wrap(Intrinsic::getDeclaration(m, Intrinsic::memmove, {params, 3}));
 }
 
-LLVMValueRef LLVMLifetimeStart(LLVMModuleRef module)
+LLVMValueRef LLVMLifetimeStart(LLVMModuleRef module, LLVMTypeRef type)
 {
   Module* m = unwrap(module);
 
+#if PONY_LLVM < 500
   return wrap(Intrinsic::getDeclaration(m, Intrinsic::lifetime_start, {}));
+#else
+  Type* t[1] = { unwrap(type) };
+  return wrap(Intrinsic::getDeclaration(m, Intrinsic::lifetime_start, t));
+#endif
 }
 
-LLVMValueRef LLVMLifetimeEnd(LLVMModuleRef module)
+LLVMValueRef LLVMLifetimeEnd(LLVMModuleRef module, LLVMTypeRef type)
 {
   Module* m = unwrap(module);
 
+#if PONY_LLVM < 500
   return wrap(Intrinsic::getDeclaration(m, Intrinsic::lifetime_end, {}));
+#else
+  Type* t[1] = { unwrap(type) };
+  return wrap(Intrinsic::getDeclaration(m, Intrinsic::lifetime_end, t));
+#endif
 }
diff --git a/src/libponyc/pass/pass.h b/src/libponyc/pass/pass.h
index 268136e77d..19230f2618 100644
--- a/src/libponyc/pass/pass.h
+++ b/src/libponyc/pass/pass.h
@@ -221,6 +221,7 @@ typedef struct pass_opt_t
   bool strip_debug;
   bool print_filenames;
   bool check_tree;
+  bool lint_llvm;
   bool docs;
   bool docs_private;
 
diff --git a/src/ponyc/main.c b/src/ponyc/main.c
index 9d3044492e..16d510d32c 100644
--- a/src/ponyc/main.c
+++ b/src/ponyc/main.c
@@ -55,6 +55,7 @@ enum
   OPT_CHECKTREE,
   OPT_EXTFUN,
   OPT_SIMPLEBUILTIN,
+  OPT_LINT_LLVM,
 
   OPT_BNF,
   OPT_ANTLR,
@@ -97,6 +98,7 @@ static opt_arg_t args[] =
   {"checktree", '\0', OPT_ARG_NONE, OPT_CHECKTREE},
   {"extfun", '\0', OPT_ARG_NONE, OPT_EXTFUN},
   {"simplebuiltin", '\0', OPT_ARG_NONE, OPT_SIMPLEBUILTIN},
+  {"lint-llvm", '\0', OPT_ARG_NONE, OPT_LINT_LLVM},
 
   {"bnf", '\0', OPT_ARG_NONE, OPT_BNF},
   {"antlr", '\0', OPT_ARG_NONE, OPT_ANTLR},
@@ -186,6 +188,7 @@ static void usage()
     "  --files         Print source file names as each is processed.\n"
     "  --bnf           Print out the Pony grammar as human readable BNF.\n"
     "  --antlr         Print out the Pony grammar as an ANTLR file.\n"
+    "  --lint-llvm     Run the LLVM linting pass on generated IR.\n"
     ,
     "Runtime options for Pony programs (not for use with ponyc):\n"
     "  --ponythreads   Use N scheduler threads. Defaults to the number of\n"
@@ -341,6 +344,7 @@ int main(int argc, char* argv[])
       case OPT_SIMPLEBUILTIN: opt.simple_builtin = true; break;
       case OPT_FILENAMES: opt.print_filenames = true; break;
       case OPT_CHECKTREE: opt.check_tree = true; break;
+      case OPT_LINT_LLVM: opt.lint_llvm = true; break;
 
       case OPT_BNF: print_grammar(false, true); return 0;
       case OPT_ANTLR: print_grammar(true, true); return 0;
diff --git a/wscript b/wscript
index 4fd539da94..63b0f3ed41 100644
--- a/wscript
+++ b/wscript
@@ -42,9 +42,9 @@ MSVC_VERSIONS = [ '15', '14' ]
 
 # keep these in sync with the list in .appveyor.yml
 LLVM_VERSIONS = [
-    '3.9.1',
-    '3.8.1',
-    '3.7.1'
+    '5.0.0',
+    '4.0.1',
+    '3.9.1'
 ]
 
 WINDOWS_LIBS_TAG = "v1.5.0"
